Skip to content

Render creatives

POST
/creatives/render
curl --request POST \
--url https://ads.wortise.com/api/public/v1/creatives/render \
--header 'Content-Type: application/json' \
--header 'x-api-key: <x-api-key>' \
--data '[ { "_id": "2489E9AD-2EE2-8E00-8EC9-32D5F69181C0", "height": 1, "trackingTag": "https://example.com", "type": "banner", "url": "example", "width": 1, "asset": { "aspectRatio": "5:4", "filename": "example", "height": 1, "size": 1, "storageKey": "example", "url": "https://example.com", "watermark": true, "watermarkUrl": "https://example.com", "width": 1, "extension": "jpeg", "type": "image" }, "brand": { "adn": { "colorScheme": "light", "colors": { "accent": "example", "background": "example", "error": "example", "link": "example", "primary": "example", "secondary": "example", "success": "example", "textPrimary": "example", "textSecondary": "example", "warning": "example" }, "components": { "buttonPrimary": { "background": "example", "borderColor": "example", "borderRadius": "example", "textColor": "example" }, "buttonSecondary": { "background": "example", "borderColor": "example", "borderRadius": "example", "textColor": "example" } }, "fonts": [ { "family": "example", "role": "example" } ], "images": { "favicon": "https://example.com", "logo": "https://example.com", "ogImage": "https://example.com", "uploadedAt": "2026-04-15T12:00:00Z" }, "personality": { "energy": "example", "targetAudience": "example", "tone": "example" }, "spacing": { "baseUnit": 1, "borderRadius": 1, "margins": { "additionalProperty": 1 }, "padding": { "additionalProperty": 1 } }, "typography": { "fontFamilies": { "code": "example", "heading": "example", "primary": "example" }, "fontSizes": { "body": "example", "h1": "example", "h2": "example", "h3": "example" }, "fontWeights": { "bold": 1, "light": 1, "medium": 1, "regular": 1 }, "lineHeights": { "additionalProperty": 1 } } }, "logo": "https://example.com", "name": "example" } } ]'

Renders assets into creative templates: returns the markup and size to save on each creative.

Requires the creatives:read scope.

Media typeapplication/json
Array<object>
object
_id
string format: uuid
/^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-4[0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12})$/
height
integer
> 0 <= 9007199254740991
trackingTag
string format: uri
type
required
string
Allowed values: banner interstitial vast
url

Destination URL (redirect)

string
width
integer
> 0 <= 9007199254740991
asset
required
One of:
object
aspectRatio
required
string
Allowed values: 5:4 9:16 2:3 21:9
filename
string
height
integer
> 0 <= 9007199254740991
size
integer
> 0 <= 9007199254740991
storageKey
string
url
required
string format: uri
watermark
boolean
watermarkUrl
string format: uri
width
integer
> 0 <= 9007199254740991
extension
required
string
Allowed values: jpeg jpg png webp
type
required
string
Allowed value: image
brand
object
adn
required
object
colorScheme
string
Allowed values: light dark
colors
object
accent
string
background
string
error
string
link
string
primary
string
secondary
string
success
string
textPrimary
string
textSecondary
string
warning
string
components
object
buttonPrimary
object
background
string
borderColor
string
borderRadius
string
textColor
string
buttonSecondary
object
background
string
borderColor
string
borderRadius
string
textColor
string
fonts
Array<object>
object
family
required
string
role
string
images
object
favicon
Any of:
string format: uri
logo
Any of:
string format: uri
ogImage
Any of:
string format: uri
uploadedAt

Upload date in storage.

string format: date-time
/^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z|([+-](?:[01]\d|2[0-3]):[0-5]\d)))$/
personality
object
energy
string
targetAudience
string
tone
string
spacing
object
baseUnit
number
borderRadius
Any of:
number
margins
object
key
additional properties
Any of:
number
padding
object
key
additional properties
Any of:
number
typography
object
fontFamilies
object
code
string
heading
string
primary
string
fontSizes
object
body
string
h1
string
h2
string
h3
string
fontWeights
object
bold
number
light
number
medium
number
regular
number
lineHeights
object
key
additional properties
Any of:
number
logo
Any of:
string format: uri
name
required
string
>= 1 characters

The rendered creatives.

Media typeapplication/json
Array<object>
object
_id
required
string format: uuid
/^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-4[0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12})$/
height
integer
> 0 <= 9007199254740991
trackingTag
string format: uri
type
required
string
Allowed values: banner interstitial vast
url

Destination URL (redirect)

string
width
integer
> 0 <= 9007199254740991
asset
required
One of:
object
aspectRatio
required
string
Allowed values: 5:4 9:16 2:3 21:9
filename
string
height
integer
> 0 <= 9007199254740991
size
integer
> 0 <= 9007199254740991
storageKey
string
url
required
string format: uri
watermark
boolean
watermarkUrl
string format: uri
width
integer
> 0 <= 9007199254740991
extension
required
string
Allowed values: jpeg jpg png webp
type
required
string
Allowed value: image
brand
object
adn
required
object
colorScheme
string
Allowed values: light dark
colors
object
accent
string
background
string
error
string
link
string
primary
string
secondary
string
success
string
textPrimary
string
textSecondary
string
warning
string
components
object
buttonPrimary
object
background
string
borderColor
string
borderRadius
string
textColor
string
buttonSecondary
object
background
string
borderColor
string
borderRadius
string
textColor
string
fonts
Array<object>
object
family
required
string
role
string
images
object
favicon
Any of:
string format: uri
logo
Any of:
string format: uri
ogImage
Any of:
string format: uri
uploadedAt

Upload date in storage.

string format: date-time
/^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z|([+-](?:[01]\d|2[0-3]):[0-5]\d)))$/
personality
object
energy
string
targetAudience
string
tone
string
spacing
object
baseUnit
number
borderRadius
Any of:
number
margins
object
key
additional properties
Any of:
number
padding
object
key
additional properties
Any of:
number
typography
object
fontFamilies
object
code
string
heading
string
primary
string
fontSizes
object
body
string
h1
string
h2
string
h3
string
fontWeights
object
bold
number
light
number
medium
number
regular
number
lineHeights
object
key
additional properties
Any of:
number
logo
Any of:
string format: uri
name
required
string
>= 1 characters
aspectRatio
required

Aspect ratio of the template

string
dimensions
required

Size of the template; save it as the creative width and height

object
height
required
integer
> 0 <= 9007199254740991
width
required
integer
> 0 <= 9007199254740991
html
required

Rendered markup; save it as the creative html

string
path
required

Template path

string

Example

[
{
"type": "banner",
"asset": {
"aspectRatio": "5:4",
"extension": "jpeg",
"type": "image"
},
"brand": {
"adn": {
"colorScheme": "light"
}
}
}
]

The JSON body is malformed or fails the input validation.

Media typeapplication/json
Any of:
object
errors
required

Zod issues

Array<object>
object
code
required
string
Allowed values: custom invalid_element invalid_format invalid_key invalid_type invalid_union invalid_value not_multiple_of too_big too_small unrecognized_keys
message
required
string
path
required

Location of the invalid field in the procedure input

Array
key
additional properties
message
required
string
Allowed value: Validation Error

Example

{
"errors": [
{
"code": "custom"
}
],
"message": "Validation Error"
}

The API key is missing, invalid, disabled or expired.

Media typeapplication/json
object
code
required

TRPC error code, e.g. UNAUTHORIZED, FORBIDDEN, NOT_FOUND, CONFLICT

string
Allowed values: PARSE_ERROR BAD_REQUEST INTERNAL_SERVER_ERROR NOT_IMPLEMENTED BAD_GATEWAY SERVICE_UNAVAILABLE GATEWAY_TIMEOUT UNAUTHORIZED PAYMENT_REQUIRED FORBIDDEN NOT_FOUND METHOD_NOT_SUPPORTED TIMEOUT CONFLICT PRECONDITION_FAILED PAYLOAD_TOO_LARGE UNSUPPORTED_MEDIA_TYPE UNPROCESSABLE_CONTENT PRECONDITION_REQUIRED TOO_MANY_REQUESTS CLIENT_CLOSED_REQUEST
message
required
string

Example

{
"code": "PARSE_ERROR"
}

The API key lacks the scope, or its owner lacks the dashboard permission.

Media typeapplication/json
object
code
required

TRPC error code, e.g. UNAUTHORIZED, FORBIDDEN, NOT_FOUND, CONFLICT

string
Allowed values: PARSE_ERROR BAD_REQUEST INTERNAL_SERVER_ERROR NOT_IMPLEMENTED BAD_GATEWAY SERVICE_UNAVAILABLE GATEWAY_TIMEOUT UNAUTHORIZED PAYMENT_REQUIRED FORBIDDEN NOT_FOUND METHOD_NOT_SUPPORTED TIMEOUT CONFLICT PRECONDITION_FAILED PAYLOAD_TOO_LARGE UNSUPPORTED_MEDIA_TYPE UNPROCESSABLE_CONTENT PRECONDITION_REQUIRED TOO_MANY_REQUESTS CLIENT_CLOSED_REQUEST
message
required
string

Example

{
"code": "PARSE_ERROR"
}

The API key exceeded its rate limit; retry after the Retry-After seconds.

Media typeapplication/json
object
code
required

TRPC error code, e.g. UNAUTHORIZED, FORBIDDEN, NOT_FOUND, CONFLICT

string
Allowed values: PARSE_ERROR BAD_REQUEST INTERNAL_SERVER_ERROR NOT_IMPLEMENTED BAD_GATEWAY SERVICE_UNAVAILABLE GATEWAY_TIMEOUT UNAUTHORIZED PAYMENT_REQUIRED FORBIDDEN NOT_FOUND METHOD_NOT_SUPPORTED TIMEOUT CONFLICT PRECONDITION_FAILED PAYLOAD_TOO_LARGE UNSUPPORTED_MEDIA_TYPE UNPROCESSABLE_CONTENT PRECONDITION_REQUIRED TOO_MANY_REQUESTS CLIENT_CLOSED_REQUEST
message
required
string

Example

{
"code": "PARSE_ERROR"
}
Retry-After
integer

Seconds to wait before retrying.

Unexpected server error.

Media typeapplication/json
object
code
required

TRPC error code, e.g. UNAUTHORIZED, FORBIDDEN, NOT_FOUND, CONFLICT

string
Allowed values: PARSE_ERROR BAD_REQUEST INTERNAL_SERVER_ERROR NOT_IMPLEMENTED BAD_GATEWAY SERVICE_UNAVAILABLE GATEWAY_TIMEOUT UNAUTHORIZED PAYMENT_REQUIRED FORBIDDEN NOT_FOUND METHOD_NOT_SUPPORTED TIMEOUT CONFLICT PRECONDITION_FAILED PAYLOAD_TOO_LARGE UNSUPPORTED_MEDIA_TYPE UNPROCESSABLE_CONTENT PRECONDITION_REQUIRED TOO_MANY_REQUESTS CLIENT_CLOSED_REQUEST
message
required
string

Example

{
"code": "PARSE_ERROR"
}